[From nobody Sun Jan  9 16:50:38 2022
Received: from Debian-exim by ganesha.gnumonks.org with local (Exim 4.72)
 id 1TcktI-0000kD-45
 for tetra-bounces@lists.osmocom.org; Sun, 25 Nov 2012 23:41:32 +0100
Date: Sun, 25 Nov 2012 23:41:32 +0100
Message-Id: &lt;E1TcktI-0000kD-45@ganesha.gnumonks.org&gt;
X-Failed-Recipients: jasperkanbier@wanadoo.nl
Auto-Submitted: auto-replied
From: Mail Delivery System &lt;Mailer-Daemon@ganesha.gnumonks.org&gt;
To: tetra-bounces@lists.osmocom.org
Subject: Mail delivery failed: returning message to sender

This message was created automatically by mail delivery software.

A message that you sent could not be delivered to one or more of its
recipients. This is a permanent error. The following address(es) failed:

  jasperkanbier@wanadoo.nl
    all relevant MX records point to non-existent hosts

------ This is a copy of the message, including all the headers. ------

Return-path: &lt;tetra-bounces@lists.osmocom.org&gt;
Received: from localhost ([127.0.0.1] helo=ganesha.gnumonks.org)
	by ganesha.gnumonks.org with esmtp (Exim 4.72)
	(envelope-from &lt;tetra-bounces@lists.osmocom.org&gt;)
	id 1Tcksf-0008Ou-H7; Sun, 25 Nov 2012 23:40:53 +0100
Received: from mail6.webfaction.com ([74.55.86.74] helo=smtp.webfaction.com)
	by ganesha.gnumonks.org with esmtp (Exim 4.72)
	(envelope-from &lt;frank@hvitehus.no&gt;) id 1TckmF-0008Ko-Gx
	for tetra@lists.osmocom.org; Sun, 25 Nov 2012 23:34:17 +0100
Received: from [192.168.10.3] (cm-84.210.199.33.getinternet.no [84.210.199.33])
	by smtp.webfaction.com (Postfix) with ESMTP id 98FD3207F9C0
	for &lt;tetra@lists.osmocom.org&gt;; Sun, 25 Nov 2012 16:31:18 -0600 (CST)
Subject: Fix some uglyness
From: &quot;Frank A. Stevenson&quot; &lt;frank@hvitehus.no&gt;
To: tetra@lists.osmocom.org
Content-Type: multipart/mixed; boundary=&quot;=-juL2tsFgP/koMyKsNZXw&quot;
Date: Sun, 25 Nov 2012 23:29:11 +0100
Message-ID: &lt;1353882551.6193.51.camel@quant&gt;
Mime-Version: 1.0
X-Mailer: Evolution 2.28.1 
X-Spam-Score: 0.0 (/)
X-BeenThere: tetra@lists.osmocom.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: development list regarding TETRA receiver/transmitter/analyzer
	&lt;tetra.lists.osmocom.org&gt;
List-Unsubscribe: &lt;https://lists.osmocom.org/mailman/options/tetra&gt;,
	&lt;mailto:tetra-request@lists.osmocom.org?subject=unsubscribe&gt;
List-Archive: &lt;http://lists.osmocom.org/pipermail/tetra&gt;
List-Post: &lt;mailto:tetra@lists.osmocom.org&gt;
List-Help: &lt;mailto:tetra-request@lists.osmocom.org?subject=help&gt;
List-Subscribe: &lt;https://lists.osmocom.org/mailman/listinfo/tetra&gt;,
	&lt;mailto:tetra-request@lists.osmocom.org?subject=subscribe&gt;
Sender: tetra-bounces@lists.osmocom.org
Errors-To: tetra-bounces@lists.osmocom.org


--=-juL2tsFgP/koMyKsNZXw
Content-Type: text/plain; charset=&quot;UTF-8&quot;
Content-Transfer-Encoding: 7bit

Attached is a patch that fixes some global ugliness. The dependencies
are a bit iffy, so you need a make clean after applying this.

This fix needs to be in place before you decode multiple carriers. I
would like to suggest that tetra-rx.c be changed so that it can receive
multiplexed streams of input. Byte values of 0 / 1 will be the primary
stream, but other values can be used to encode the multiplexed streams.

The easiest method is to use the high order bits of the input as a
&quot;stream id&quot;, and dynamically create new state structs as they appear in
the stream.

Does this sound like a decent solution ?

  f

--=-juL2tsFgP/koMyKsNZXw
Content-Disposition: attachment; filename=&quot;fix_ugly.diff&quot;
Content-Type: text/x-patch; name=&quot;fix_ugly.diff&quot;; charset=&quot;UTF-8&quot;
Content-Transfer-Encoding: 7bit

diff --git a/src/tetra_common.h b/src/tetra_common.h
index 3169b8a..3207c0d 100644
--- a/src/tetra_common.h
+++ b/src/tetra_common.h
@@ -2,7 +2,7 @@
 #define TETRA_COMMON_H
 
 #include &lt;stdint.h&gt;
-
+#include &quot;tetra_mac_pdu.h&quot;
 #include &lt;osmocom/core/linuxlist.h&gt;
 
 #ifdef DEBUG
@@ -47,6 +47,7 @@ struct tetra_mac_state {
 	struct {
 		int is_traffic;
 	} cur_burst;
+    struct tetra_si_decoded last_sid;
 };
 
 void tetra_mac_state_init(struct tetra_mac_state *tms);
diff --git a/src/tetra_upper_mac.c b/src/tetra_upper_mac.c
index 0bfc0e1..e5b9f30 100644
--- a/src/tetra_upper_mac.c
+++ b/src/tetra_upper_mac.c
@@ -40,9 +40,6 @@
 
 static int rx_tm_sdu(struct tetra_mac_state *tms, struct msgb *msg, unsigned int len);
 
-/* FIXME: this is ugly */
-static struct tetra_si_decoded g_last_sid;
-
 static void rx_bcast(struct tetra_tmvsap_prim *tmvp, struct tetra_mac_state *tms)
 {
 	struct msgb *msg = tmvp-&gt;oph.msg;
@@ -74,10 +71,10 @@ static void rx_bcast(struct tetra_tmvsap_prim *tmvp, struct tetra_mac_state *tms
 		printf(&quot;\t%s: %u\n&quot;, tetra_get_bs_serv_det_name(1 &lt;&lt; i),
 			sid.mle_si.bs_service_details &amp; (1 &lt;&lt; i) ? 1 : 0);
 
-	memcpy(&amp;g_last_sid, &amp;sid, sizeof(sid));
+	memcpy(&amp;tms-&gt;last_sid, &amp;sid, sizeof(sid));
 }
 
-const char *tetra_alloc_dump(const struct tetra_chan_alloc_decoded *cad)
+const char *tetra_alloc_dump(const struct tetra_chan_alloc_decoded *cad, struct tetra_mac_state *tms)
 {
 	static char buf[64];
 	char *cur = buf;
@@ -87,8 +84,8 @@ const char *tetra_alloc_dump(const struct tetra_chan_alloc_decoded *cad)
 		freq_band = cad-&gt;ext_carr.freq_band;
 		freq_offset = cad-&gt;ext_carr.freq_offset;
 	} else {
-		freq_band = g_last_sid.freq_band;
-		freq_offset = g_last_sid.freq_offset;
+		freq_band = tms-&gt;last_sid.freq_band;
+		freq_offset = tms-&gt;last_sid.freq_offset;
 	}
 
 	cur += sprintf(cur, &quot;%s (TN%u/%s/%uHz)&quot;,
@@ -170,7 +167,7 @@ static void rx_resrc(struct tetra_tmvsap_prim *tmvp, struct tetra_mac_state *tms
 		goto out;
 
 	if (rsd.chan_alloc_pres)
-		printf(&quot;ChanAlloc=%s &quot;, tetra_alloc_dump(&amp;rsd.cad));
+		printf(&quot;ChanAlloc=%s &quot;, tetra_alloc_dump(&amp;rsd.cad, tms));
 
 	if (rsd.slot_granting.pres)
 		printf(&quot;SlotGrant=%u/%u &quot;, rsd.slot_granting.nr_slots,

--=-juL2tsFgP/koMyKsNZXw--



]